# Changelog
All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## [Unreleased]

## [0.4.1](https://github.com/robertpsoane/ducker/compare/v0.4.0...v0.4.1) - 2025-07-02

### Other

- *(deps)* bump tempfile from 3.18.0 to 3.20.0 ([#189](https://github.com/robertpsoane/ducker/pull/189))

## [0.4.0](https://github.com/robertpsoane/ducker/compare/v0.3.1...v0.4.0) - 2025-06-30

### Added

- sort by column functionality to list views ([#173](https://github.com/robertpsoane/ducker/pull/173))

### Fixed

- remove flaky tests ... again ([#184](https://github.com/robertpsoane/ducker/pull/184))
- autocomplete minimum number of characters is now configurable
- env unix test only runs on unix
- remove ineffective tests

### Other

- *(deps)* bump various dependencies ([#179](https://github.com/robertpsoane/ducker/pull/179))
- *(docs)* fix heading depth in sorting ([#186](https://github.com/robertpsoane/ducker/pull/186))
- :sparkles: feat: SSL via Rustls
- :bug: fix: only process key press events in event loop
- *(deps)* bump chrono from 0.4.39 to 0.4.41
- *(deps)* bump dyn-clone from 1.0.18 to 1.0.19
- *(deps)* bump tokio from 1.43.0 to 1.45.1
- *(deps)* bump serde from 1.0.218 to 1.0.219

## [0.3.1](https://github.com/robertpsoane/ducker/compare/v0.3.0...v0.3.1) - 2025-06-28

### Other

- Minor change to use https in the github url in Cargo.toml ([#167](https://github.com/robertpsoane/ducker/pull/167))

## [0.3.0](https://github.com/robertpsoane/ducker/compare/v0.2.4...v0.3.0) - 2025-03-08

### Added

- respect DOCKER_HOST environment variable ([#150](https://github.com/robertpsoane/ducker/pull/150))

### Fixed

- attempt to fix failing tcp test ([#152](https://github.com/robertpsoane/ducker/pull/152))

### Other

- *(deps)* bump dyn-clone from 1.0.17 to 1.0.18 ([#140](https://github.com/robertpsoane/ducker/pull/140))
- *(deps)* bump serde from 1.0.217 to 1.0.218 ([#145](https://github.com/robertpsoane/ducker/pull/145))
- *(deps)* bump async-trait from 0.1.85 to 0.1.87 ([#147](https://github.com/robertpsoane/ducker/pull/147))
- *(deps)* bump clap from 4.5.26 to 4.5.31 ([#148](https://github.com/robertpsoane/ducker/pull/148))
- *(deps)* bump tokio from 1.42.0 to 1.43.0 ([#135](https://github.com/robertpsoane/ducker/pull/135))
- *(deps)* bump clap from 4.5.23 to 4.5.26 ([#134](https://github.com/robertpsoane/ducker/pull/134))
- *(deps)* bump async-trait from 0.1.83 to 0.1.85 ([#133](https://github.com/robertpsoane/ducker/pull/133))
- *(deps)* bump itertools from 0.13.0 to 0.14.0 ([#132](https://github.com/robertpsoane/ducker/pull/132))
- *(deps)* bump serde from 1.0.216 to 1.0.217 ([#130](https://github.com/robertpsoane/ducker/pull/130))

## [0.2.4](https://github.com/robertpsoane/ducker/compare/v0.2.3...v0.2.4) - 2024-12-24

### Other

- *(deps)* bump serde from 1.0.215 to 1.0.216 (#128)

## [0.2.3](https://github.com/robertpsoane/ducker/compare/v0.2.2...v0.2.3) - 2024-12-14

### Fixed

- *(docs)* networks docs refer to network instead of volumes (#126)

## [0.2.2](https://github.com/robertpsoane/ducker/compare/v0.2.1...v0.2.2) - 2024-12-09

### Other

- *(deps)* bump chrono from 0.4.38 to 0.4.39 (#122)
- *(deps)* bump tokio from 1.41.1 to 1.42.0 (#121)
- *(deps)* bump ureq from 2.11.0 to 2.12.1 (#123)
- *(deps)* bump clap from 4.5.22 to 4.5.23 (#124)

## [0.2.1](https://github.com/robertpsoane/ducker/compare/v0.2.0...v0.2.1) - 2024-12-04

### Fixed

- *(deps)* update clap ([#119](https://github.com/robertpsoane/ducker/pull/119))

## [0.2.0](https://github.com/robertpsoane/ducker/compare/v0.1.6...v0.2.0) - 2024-12-01

### Other

- *(deps)* update a range of dependencies ([#117](https://github.com/robertpsoane/ducker/pull/117))

## [0.1.6](https://github.com/robertpsoane/ducker/compare/v0.1.5...v0.1.6) - 2024-12-01

### Other

- *(deps)* bump tokio from 1.40.0 to 1.41.1 ([#112](https://github.com/robertpsoane/ducker/pull/112))
- *(deps)* bump serde from 1.0.210 to 1.0.215 ([#114](https://github.com/robertpsoane/ducker/pull/114))
- update brew installation to use the official tap ([#115](https://github.com/robertpsoane/ducker/pull/115))

## [0.1.5](https://github.com/robertpsoane/ducker/compare/v0.1.4...v0.1.5) - 2024-10-18

### Other

- updates to README
- *(deps)* bump async-trait from 0.1.82 to 0.1.83 ([#99](https://github.com/robertpsoane/ducker/pull/99))
- *(deps)* bump clap from 4.5.17 to 4.5.20 ([#102](https://github.com/robertpsoane/ducker/pull/102))
- *(deps)* bump futures from 0.3.30 to 0.3.31 ([#100](https://github.com/robertpsoane/ducker/pull/100))

## [0.1.4](https://github.com/robertpsoane/ducker/compare/v0.1.3...v0.1.4) - 2024-09-09

### Other

- *(deps)* bump clap from 4.5.16 to 4.5.17 ([#94](https://github.com/robertpsoane/ducker/pull/94))
- *(deps)* bump serde from 1.0.209 to 1.0.210 ([#95](https://github.com/robertpsoane/ducker/pull/95))
- *(deps)* bump ansi-to-tui from 4.0.1 to 6.0.0 ([#93](https://github.com/robertpsoane/ducker/pull/93))

## [0.1.3](https://github.com/robertpsoane/ducker/compare/v0.1.2...v0.1.3) - 2024-09-08

### Other

- *(deps)* bump tokio from 1.39.3 to 1.40.0 ([#91](https://github.com/robertpsoane/ducker/pull/91))
- *(deps)* bump async-trait from 0.1.81 to 0.1.82 ([#90](https://github.com/robertpsoane/ducker/pull/90))

## [0.1.2](https://github.com/robertpsoane/ducker/compare/v0.1.1...v0.1.2) - 2024-08-31

### Other
- *(deps)* bump bollard from 0.16.1 to 0.17.1 ([#80](https://github.com/robertpsoane/ducker/pull/80))
- *(deps)* bump serde from 1.0.208 to 1.0.209 ([#86](https://github.com/robertpsoane/ducker/pull/86))
- *(deps)* bump ratatui from 0.28.0 to 0.28.1 ([#88](https://github.com/robertpsoane/ducker/pull/88))
- *(deps)* bump serde_yml from 0.0.11 to 0.0.12 ([#87](https://github.com/robertpsoane/ducker/pull/87))
- *(deps)* bump tokio from 1.39.2 to 1.39.3 ([#82](https://github.com/robertpsoane/ducker/pull/82))
- *(deps)* bump serde from 1.0.207 to 1.0.208 ([#83](https://github.com/robertpsoane/ducker/pull/83))
- *(deps)* bump ureq from 2.10.0 to 2.10.1 ([#81](https://github.com/robertpsoane/ducker/pull/81))
- *(deps)* bump clap from 4.5.15 to 4.5.16 ([#79](https://github.com/robertpsoane/ducker/pull/79))
- update instructions for Arch Linux ([#74](https://github.com/robertpsoane/ducker/pull/74))
- fix typo in README.md ([#75](https://github.com/robertpsoane/ducker/pull/75))

## [0.1.1](https://github.com/robertpsoane/ducker/compare/v0.1.0...v0.1.1) - 2024-08-14

### Other
- *(deps)* bump clap from 4.5.13 to 4.5.15 ([#69](https://github.com/robertpsoane/ducker/pull/69))
- *(deps)* bump serde from 1.0.204 to 1.0.207 ([#72](https://github.com/robertpsoane/ducker/pull/72))

## [0.1.0](https://github.com/robertpsoane/ducker/compare/v0.0.7...v0.1.0) - 2024-08-14

Over the past few weeks I've had little time to add to Ducker, however I've been trying to keep on top of dependencies.  I've decided to bump to v0.1.0 as Ducker's approaching a near-stable point, and to allow the semver to determine between feature update & changes and dependency patches.

### Other
- *(deps)* bump ratatui to 0.28.0 ([#70](https://github.com/robertpsoane/ducker/pull/70))
- *(deps)* bump crossterm from 0.27.0 to 0.28.1 ([#62](https://github.com/robertpsoane/ducker/pull/62))
- *(deps)* bump clap from 4.5.11 to 4.5.13 ([#63](https://github.com/robertpsoane/ducker/pull/63))
- *(deps)* bump tui-big-text from 0.5.2 to 0.5.3 ([#64](https://github.com/robertpsoane/ducker/pull/64))
- *(deps)* bump tui-big-text from 0.4.5 to 0.5.2 ([#60](https://github.com/robertpsoane/ducker/pull/60))
- *(deps)* bump tokio from 1.38.1 to 1.39.2 ([#58](https://github.com/robertpsoane/ducker/pull/58))
- *(deps)* bump clap from 4.5.9 to 4.5.11 ([#57](https://github.com/robertpsoane/ducker/pull/57))
- *(deps)* bump serde_yml from 0.0.10 to 0.0.11 ([#53](https://github.com/robertpsoane/ducker/pull/53))
- *(deps)* bump ratatui-macros from 0.4.2 to 0.4.3 ([#54](https://github.com/robertpsoane/ducker/pull/54))
- *(deps)* bump tokio from 1.38.0 to 1.38.1 ([#55](https://github.com/robertpsoane/ducker/pull/55))

## [0.0.7](https://github.com/robertpsoane/ducker/compare/v0.0.6...v0.0.7) - 2024-07-17

### Added
- *(tracing)* add initial tracing to ~/.local/share/ducker/ducker.log ([#49](https://github.com/robertpsoane/ducker/pull/49))
- initial network page ([#47](https://github.com/robertpsoane/ducker/pull/47))
- add support for listing volumes ([#44](https://github.com/robertpsoane/ducker/pull/44))

### Other
- *(config)* use arc instead of box for config ([#52](https://github.com/robertpsoane/ducker/pull/52))
- *(deps)* bump clap from 4.5.8 to 4.5.9 ([#51](https://github.com/robertpsoane/ducker/pull/51))
- *(versions)* use ureq instead of reqwest for version checks ([#48](https://github.com/robertpsoane/ducker/pull/48))
- symlink demo.gif to fix old cargo docs
- *(readme)* add a note about using `--locked` to cargo installs
- add an ai generated image of a duck riding a whale ([#45](https://github.com/robertpsoane/ducker/pull/45))

## [0.0.6](https://github.com/robertpsoane/ducker/compare/v0.0.5...v0.0.6) - 2024-07-11

Over the past few days I have added a few small features, as well as bumping some dependency versions where there have been known vulnerabilities.
One of the new features is a visual prompt that there is a new version.  This makes one network request at the beginning of each ducker session, but can be switched off in the config.  The bottom right of the screen shows the current version, and when there is a new version, it will show both.  I hope this is minimally intrusive, and am open to feedback.

The other main feature is the option to choose which command to exec into the shell as.  I'm not entirely happy with how it's presented to the user and once I've got modals sorted I will probably change this up a bit.  Similarly I'm wondering if its worth having two exec actions, one to use the default and one to offer the pop-up?

I have been giving versioning a bit of thought; when I started this I thought I'd start with v0.0.1 to signify the lack of completeness.  I intend to add initial support for volumes and networks, as well as get some unit test coverage (so I have some degree of trust in the stability of the system!) before bumping to v0.1.0.

### Added
- option to display all logs
- initial optional exec command
- add version info to bottom right of screen

### Other
- start using macros for layouts
- update to issues roadmap
- *(deps)* bump zerovec from 0.10.2 to 0.10.4
- *(deps)* bump serde from 1.0.203 to 1.0.204
- *(deps)* bump async-trait from 0.1.80 to 0.1.81

## [0.0.5](https://github.com/robertpsoane/ducker/compare/v0.0.4...v0.0.5) - 2024-07-07

When consolidating the command field to use a common text input widget as part of the plan to add more user options, I came across a regression in `exec`; in essence the exec action fails, which isn't ideal.

This was introduced as part of the changes to the transition payloads.  Unfortunately I'm not yet at a point where there is a test suite for the project (see the [pinned issue](https://github.com/robertpsoane/ducker/issues/2)  for some wider context as to how this project got to where it is) - I think this highlights that that needs prioritising.

### Fixed
- fix!(attach): exec regression fixed

### Other
- use new text input widget
- add brew commands ([#32](https://github.com/robertpsoane/ducker/pull/32))
- add CONTRIBUTING.md
- fix cargo.toml to include license from correct source

## [0.0.4](https://github.com/robertpsoane/ducker/compare/v0.0.3...v0.0.4) - 2024-07-06

### Added
- add ability for more detailed summary of images
- add ability for more detailed container description and stats ([#17](https://github.com/robertpsoane/ducker/pull/17))

### Other
- describe uses a trait object
- *(deps)* bump clap from 4.5.6 to 4.5.8
- *(pages)* simplify page lifecycle removing the redundant concept of visibility

## [0.0.3](https://github.com/robertpsoane/ducker/compare/v0.0.2...v0.0.3) - 2024-06-30

### Added
- docker socket is configurable
- *(images)* toggle to show dangling images
- *(config)* introduce initial config system providing basic customisability
- *(cli)* add minimal clap commands

### Fixed
- *(history)* don't panic when attempting to view non-existent history in input field
- stop and delete containers in tokio task
- consistent help messaging for jump to top and bottom
- *(images)* g & G jump between top and bottom on image page

### Other
- improve README
- minimal user manual in README.md
- use mod.rs across the codebase
- *(issues)* update issues with feedback
- *(docs)* update issue templates
- *(logs)* simplify logs pane using list selection features introduced in ratatui 0.27.0
- add AUR instructions

## [0.0.2](https://github.com/robertpsoane/ducker/compare/v0.0.1...v0.0.2) - 2024-06-27

### Fixed
- *(ci)* fix ci formatting
- update readme with `--locked`
- add initial ci
- fix clippy

### Other
- fix formatting
- updates to installation instructions
